﻿using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace DemoCSharp8
{
    public class AsyncStream
    {
        public AsyncStream()
        {
            AsyncStreamAsync().Wait();
        }

        private async Task AsyncStreamAsync()
        {
            Console.WriteLine("Stampo i valori della sequenza...");
            var s1 = await GetSequenceAsync();

            foreach (var item in s1)
                Console.WriteLine(item);

            #region after
            Console.WriteLine();
            Console.WriteLine($"Stampo i valori della sequenza async...");


            var s2 = GetSequenceAsync(0, 10);


            await foreach (var item in s2)
                Console.WriteLine(item);


            #endregion
        }

        private async Task<IEnumerable<int>> GetSequenceAsync()
        {
            // PROBLEMI:
            // 1. Devo allocare una variabile per tenere la lista degli oggetti: non posso usare yield
            // 2. Essendo asincrona, devo per forza fare una await: tutti i risultati ritornano in un colpo solo...

            int skip = 0;
            int take = 10;
            var collection = new List<int>();

            for (int i = skip; i < take; i++)
            {
                await Task.Delay(1000);
                collection.Add(i);
            }

            return collection;
        }

#region after
        private async IAsyncEnumerable<int> GetSequenceAsync(int skip, int take)
        {
            for (int i = skip; i < take; i++)
            {
                await Task.Delay(1000);
                yield return i;
            }
        }
#endregion
    }
}