﻿using System;

namespace DemoCSharp8
{
    public class DefaultInterfaceMembers
    {
        public DefaultInterfaceMembers(ILogger logger)
        {
            logger.Log("messaggio di errore");
            logger.Log(new Exception("messaggio di errore da exception"));
        }
    }

    public interface ILogger
    {
        void Log(string message);
        void Log(Exception ex) => Log(ex.Message);
    }

    public class Logger : ILogger
    {
        public void Log(string message)
        {
            Console.WriteLine(message);
        }

        public void Log(Exception ex)
        {
            this.Log($"[{nameof(Log)} from {nameof(Logger)}] {ex.Message}");
        }
    }

    public class DefaultLogger : ILogger
    {
        public void Log(string message)
        {
            Console.WriteLine(message);
        }
    }
}