﻿using System;
using static System.Console;
using System.Text.Json;

namespace DemoCSharp8
{
    public class JsonSerialization
    {
        public JsonSerialization()
        {
            var weather = new Weather
            {
                Date = DateTime.Now,
                Summary = "Seems sunny",
                TemperatureC = 25
            };

            var json = SerializePrettyPrint(weather);
            var dataBack = Deserialize(json);

            WriteLine(json);
        }

        private string SerializePrettyPrint(Weather value)
        {
            var options = new JsonSerializerOptions
            {
                WriteIndented = true                
            };

            return JsonSerializer.Serialize(value, options);
        }

        public Weather Deserialize(string json) =>
            JsonSerializer.Deserialize<Weather>(json);

        public class Weather
        {
            public DateTimeOffset Date { get; set; }
            public int TemperatureC { get; set; }
            public string? Summary { get; set; }
        }
    }
}