﻿using static System.Console;

namespace DemoCSharp8
{
    public class NullableReferenceTypes
    {
        public NullableReferenceTypes()
        {
            var p1 = new Person("Matteo", "Tumiati");
            WriteLine(GetFullNameLength(p1));
        }

        private int GetFullNameLength(Person person)
        {
            person.Setup();

            return person.FirstName.Length +
                   person.MiddleName!.Length +
                   person.LastName.Length;
        }

        public class Person
        {
            public string FirstName { get; set; }
            public string? MiddleName { get; set; }
            public string LastName { get; set; }

            public Person(string firstName, string lastName)
            {
                FirstName = firstName;
                MiddleName = null;
                LastName = lastName;
            }

            public Person(string firstName, string middleName, string lastName)
            {
                FirstName = firstName;
                MiddleName = middleName;
                LastName = lastName;
            }

            public void Setup()
            {
                MiddleName = string.Empty;
            }
        }
    }
}
