﻿using System;
using System.IO;
using System.Text;

namespace DemoCSharp8
{
    public class UsingDeclarations
    {
        public UsingDeclarations()
        {
            _ = ReadFileContent();
            _ = ReadFileContentV2();
            _ = ReadFileContentV3();
            _ = ReadFileContentV4();
        }

        public string ReadFileContent()
        {
            using (var file = new FileStream("TextFile.txt", FileMode.Open))
            {
                using (var reader = new StreamReader(file))
                {
                    return reader.ReadToEnd();
                }
            }
        }

        public string ReadFileContentV2()
        {
            using var file = new FileStream("TextFile.txt", FileMode.Open);
            using var reader = new StreamReader(file);
            return reader.ReadToEnd();
        }

        public string ReadFileContentV3()
        {
            var buffer = new byte[100];
            using var stream = File.OpenRead("TextFile.txt");
            var bytesRead = stream.Read(buffer, 0, buffer.Length);

            // buffer contiene delle parti vuote e allocazioni inutili... come lo semplifichiamo?
            return Encoding.UTF8.GetString(buffer);
        }

        public string ReadFileContentV4()
        {
            var buffer = new byte[100].AsSpan();
            using var stream = File.OpenRead("TextFile.txt");
            var bytesRead = stream.Read(buffer);

            var slice = buffer.Slice(0, bytesRead);

            return Encoding.UTF8.GetString(slice);
        }
    }
}