﻿using BenchmarkDotNet.Attributes;

namespace PerformanceTests
{
    [MemoryDiagnoser]
    public class JsonSerializationPerformance
    {
        private readonly string json = @"{
                ""Date"": ""2019-10-5T00:00:00Z"",
                ""Temperature"": ""25"",
                ""Summary"", ""Sunny""
            }";

        [Benchmark]
        public string SerializeWithSystemText() =>
            System.Text.Json.JsonSerializer.Serialize(json);

        [Benchmark]
        public string SerializeWithNewtonsoft() =>
            Newtonsoft.Json.JsonConvert.SerializeObject(json);
    }
}