﻿using System;
using BenchmarkDotNet.Attributes;
using DemoCSharp8;

namespace PerformanceTests
{
    [MemoryDiagnoser]
    public class SubstringPerformance
    {
        private readonly SpanAndMemory sm = new SpanAndMemory();

        [Params("Mario Rossi", "Antonio De Michele", "Giuseppe Verdi")]
        public string name;

        [Benchmark]
        public string GetLastNameUsingSubstring() => sm.GetLastNameUsingSubstring(name);

        [Benchmark]
        public ReadOnlySpan<char> GetLastNameWithSpan() => sm.GetLastNameWithSpan(name);
    }
}